Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Swing 1.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## javax.swing.text
Class CompositeView

    java.lang.Object
      |
      +--javax.swing.text.View
            |
            +--javax.swing.text.CompositeView

Direct Known Subclasses:
  BoxView

public abstract class CompositeView
extends View

A view of a text model that has a children box. If the box is vertical, it might be useful to represent something like a collection of lines or paragraphs. If the box is horizontal, it might be used to represent unwrapped lines.

Fields inherited from class javax.swing.text.View
`BadBreakWeight, ExcellentBreakWeight, ForcedBreakWeight, GoodBreakWeight, X_AXIS, Y_AXIS`

Constructor Summary
`CompositeView(Element elem)` Constructs a CompositeView for the given element.

Method Summary
`void` | `append(View v)` Appends a single child view.
`protected abstract void` | `childAllocation(int index, java.awt.Rectangle a)` Returns the allocation for a given child.
`protected boolean` | `flipEastAndWestAtEnds(int position, Position.Bias bias)` Subclasses may wish to subclass this and conditionally return true based on the position.
`protected short` | `getBottomInset()` Gets the bottom inset.
`java.awt.Shape` | `getChildAllocation(int index, java.awt.Shape a)` Fetches the allocation for the given child view.
`protected java.awt.Rectangle` | `getInsideAllocation(java.awt.Shape a)` Translates the allocation given to the view to the allocation used for composing the interior.
`protected short` | `getLeftInset()` Gets the left inset.
`protected int` | `getNextEastWestVisualPositionFrom(int pos, Position.Bias b, java.awt.Shape a, int direction, Position.Bias[] biasRet)` Returns the next visual position for the cursor, in either the east or west direction.
`protected int` | `getNextNorthSouthVisualPositionFrom(int pos, Position.Bias b, java.awt.Shape a, int direction, Position.Bias[] biasRet)` Returns the next visual position for the cursor, in either the east or west direction.
`int` | `getNextVisualPositionFrom(int pos, Position.Bias b, java.awt.Shape a, int direction, Position.Bias[] biasRet)` Provides a way to determine the next visually represented model location that one might place a caret.
`protected short` | `getRightInset()` Gets the right inset.
`protected short` | `getTopInset()` Gets the top inset.
`View` | `getView(int n)` Gets the n-th view in this container.
`protected abstract View` | `getViewAtPoint(int x, int y, java.awt.Rectangle alloc)` Fetches the child view at the given point.
`protected View` | `getViewAtPosition(int pos, java.awt.Rectangle a)` Fetches the child view that represents the given position in the model.
`int` | `getViewCount()` Returns the number of views in this view.
`protected int` | `getViewIndexAtPosition(int pos)` Fetches the child view index representing the given position in the model.
`void` | `insert(int offs, View v)` Inserts a single child view.
`protected abstract boolean` | `isAfter(int x, int y, java.awt.Rectangle alloc)` Tests whether a point lies after the rectangle range.
`protected abstract boolean` | `isBefore(int x, int y, java.awt.Rectangle alloc)` Tests whether a point lies before the rectangle range.
`protected void` | `loadChildren(ViewFactory f)` Loads all of the children to initialize the view.
`java.awt.Shape` | `modelToView(int p0, Position.Bias b0, int p1, Position.Bias b1, java.awt.Shape a)` Provides a mapping from the document model coordinate space to the coordinate space of the view mapped to it.
`java.awt.Shape` | `modelToView(int pos, java.awt.Shape a, Position.Bias b)` Provides a mapping from the document model coordinate space to the coordinate space of the view mapped to it.
`void` | `removeAll()` Removes all of the children.
`void` | `replace(int offset, int length, View[] views)` Invalidates the layout and resizes the cache of requests/allocations, allowing for the replacement of child views.
`protected void` | `setInsets(short top, short left, short bottom, short right)` Sets the insets for the view.
`protected void` | `setParagraphInsets(AttributeSet attr)` Sets the insets from the paragraph attributes specified in the given attributes.
`void` | `setParent(View parent)` Sets the parent of the view.
`int` | `viewToModel(float x, float y, java.awt.Shape a, Position.Bias[] bias)` Provides a mapping from the view coordinate space to the logical coordinate space of the model.

Methods inherited from class javax.swing.text.View
`breakView, changedUpdate, createFragment, getAlignment, getAttributes, getBreakWeight, getContainer, getDocument, getElement, getEndOffset, getMaximumSpan, getMinimumSpan, getParent, getPreferredSpan, getResizeWeight, getStartOffset, getViewFactory, insertUpdate, isVisible, modelToView, paint, preferenceChanged, removeUpdate, setSize, viewToModel`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### CompositeView

    public CompositeView(Element elem)

  Constructs a CompositeView for the given element.
  Parameters:
    `elem` - the element this view is responsible for

Method Detail

### loadChildren

    protected void loadChildren(ViewFactory f)

  Loads all of the children to initialize the view. This is called by the `setParent` method. Subclasses can reimplement this to initialize their child views in a different manner. The default implementation creates a child view for each child element.
  Parameters:
    `f` - the view factory

### removeAll

    public void removeAll()

  Removes all of the children.

### insert

    public void insert(int offs,
                       View v)

  Inserts a single child view.
  Parameters:
    `offs` - the offset of the view to insert before >= 0
    `v` - the view

### append

    public void append(View v)

  Appends a single child view.
  Parameters:
    `v` - the view

### replace

    public void replace(int offset,
                        int length,
                        View[] views)

  Invalidates the layout and resizes the cache of requests/allocations, allowing for the replacement of child views.
  Parameters:
    `offset` - the starting offset into the child views to insert before >= 0
    `length` - the number of existing child views affected >= 0
    `views` - the child views to use as replacements

### setParent

    public void setParent(View parent)

  Sets the parent of the view. This is reimplemented to provide the superclass behavior as well as calling the `loadChildren` method. The children should not be loaded in the constructor because the act of setting the parent may cause them to try to search up the hierarchy (to get the hosting Container for example).
  Parameters:
    `parent` - the parent of the view, null if none
  Overrides:
    setParent in class View

### getViewCount

    public int getViewCount()

  Returns the number of views in this view.
  Returns:
    the number of views >= 0
  Overrides:
    getViewCount in class View
  See Also:
    `getView(int)`

### getView

    public View getView(int n)

  Gets the n-th view in this container.
  Parameters:
    `n` - the number of the view to get, >= 0 && < getViewCount()
  Returns:
    the view
  Overrides:
    getView in class View

### getChildAllocation

    public java.awt.Shape getChildAllocation(int index,
                                             java.awt.Shape a)

  Fetches the allocation for the given child view. This enables finding out where various views are located, without assuming the views store their location.
  Parameters:
    `index` - the index of the child, >= 0 && < getViewCount()
    `a` - the allocation to this view.
  Returns:
    the allocation to the child
  Overrides:
    getChildAllocation in class View

### modelToView

    public java.awt.Shape modelToView(int pos,
                                      java.awt.Shape a,
                                      Position.Bias b)
                               throws BadLocationException

  Provides a mapping from the document model coordinate space to the coordinate space of the view mapped to it.
  Parameters:
    `pos` - the position to convert >= 0
    `a` - the allocated region to render into
  Returns:
    the bounding box of the given position
  Throws:
    BadLocationException - if the given position does not represent a valid location in the associated document
  Overrides:
    modelToView in class View
  See Also:
    `View.modelToView(int, java.awt.Shape, javax.swing.text.Position.Bias)`

### modelToView

    public java.awt.Shape modelToView(int p0,
                                      Position.Bias b0,
                                      int p1,
                                      Position.Bias b1,
                                      java.awt.Shape a)
                               throws BadLocationException

  Provides a mapping from the document model coordinate space to the coordinate space of the view mapped to it.
  Parameters:
    `p0` - the position to convert >= 0
    `b0` - the bias toward the previous character or the next character represented by p0, in case the position is a boundary of two views.
    `p1` - the position to convert >= 0
    `b1` - the bias toward the previous character or the next character represented by p1, in case the position is a boundary of two views.
    `a` - the allocated region to render into
  Returns:
    the bounding box of the given position is returned
  Throws:
    BadLocationException - if the given position does not represent a valid location in the associated document
    java.lang.IllegalArgumentException - for an invalid bias argument
  Overrides:
    modelToView in class View
  See Also:
    `View.viewToModel(float, float, java.awt.Shape, javax.swing.text.Position.Bias[])`

### viewToModel

    public int viewToModel(float x,
                           float y,
                           java.awt.Shape a,
                           Position.Bias[] bias)

  Provides a mapping from the view coordinate space to the logical coordinate space of the model.
  Parameters:
    `x` - x coordinate of the view location to convert >= 0
    `y` - y coordinate of the view location to convert >= 0
    `a` - the allocated region to render into
  Returns:
    the location within the model that best represents the given point in the view >= 0
  Overrides:
    viewToModel in class View
  See Also:
    `View.viewToModel(float, float, java.awt.Shape, javax.swing.text.Position.Bias[])`

### getNextVisualPositionFrom

    public int getNextVisualPositionFrom(int pos,
                                         Position.Bias b,
                                         java.awt.Shape a,
                                         int direction,
                                         Position.Bias[] biasRet)
                                  throws BadLocationException

  Provides a way to determine the next visually represented model location that one might place a caret. Some views may not be visible, they might not be in the same order found in the model, or they just might not allow access to some of the locations in the model.
  Parameters:
    `pos` - the position to convert >= 0
    `a` - the allocated region to render into
    `direction` - the direction from the current position that can be thought of as the arrow keys typically found on a keyboard. This may be SwingConstants.WEST, SwingConstants.EAST, SwingConstants.NORTH, or SwingConstants.SOUTH.
  Returns:
    the location within the model that best represents the next location visual position.
  Throws:
    BadLocationException -
    java.lang.IllegalArgumentException - for an invalid direction
  Overrides:
    getNextVisualPositionFrom in class View

### isBefore

    protected abstract boolean isBefore(int x,
                                        int y,
                                        java.awt.Rectangle alloc)

  Tests whether a point lies before the rectangle range.
  Parameters:
    `x` - the X coordinate >= 0
    `y` - the Y coordinate >= 0
    `alloc` - the rectangle
  Returns:
    true if the point is before the specified range

### isAfter

    protected abstract boolean isAfter(int x,
                                       int y,
                                       java.awt.Rectangle alloc)

  Tests whether a point lies after the rectangle range.
  Parameters:
    `x` - the X coordinate >= 0
    `y` - the Y coordinate >= 0
    `alloc` - the rectangle
  Returns:
    true if the point is after the specified range

### getViewAtPoint

    protected abstract View getViewAtPoint(int x,
                                           int y,
                                           java.awt.Rectangle alloc)

  Fetches the child view at the given point.
  Parameters:
    `x` - the X coordinate >= 0
    `y` - the Y coordinate >= 0
    `alloc` - the parent's allocation on entry, which should be changed to the child's allocation on exit
  Returns:
    the child view

### childAllocation

    protected abstract void childAllocation(int index,
                                            java.awt.Rectangle a)

  Returns the allocation for a given child.
  Parameters:
    `index` - the index of the child, >= 0 && < getViewCount()
    `a` - the allocation to the interior of the box on entry, and the allocation of the view containing the position on exit

### getViewAtPosition

    protected View getViewAtPosition(int pos,
                                     java.awt.Rectangle a)

  Fetches the child view that represents the given position in the model. This is implemented to fetch the view in the case where there is a child view for each child element.
  Parameters:
    `pos` - the position >= 0
    `a` - the allocation to the interior of the box on entry, and the allocation of the view containing the position on exit

### getViewIndexAtPosition

    protected int getViewIndexAtPosition(int pos)

  Fetches the child view index representing the given position in the model. This is implemented to fetch the view in the case where there is a child view for each child element.
  Parameters:
    `pos` - the position >= 0

### getInsideAllocation

    protected java.awt.Rectangle getInsideAllocation(java.awt.Shape a)

  Translates the allocation given to the view to the allocation used for composing the interior. This takes into account any margins that were specified.
  Parameters:
    `a` - The allocation given to the view.

### setParagraphInsets

    protected final void setParagraphInsets(AttributeSet attr)

  Sets the insets from the paragraph attributes specified in the given attributes.
  Parameters:
    `attr` - the attributes

### setInsets

    protected final void setInsets(short top,
                                   short left,
                                   short bottom,
                                   short right)

  Sets the insets for the view.
  Parameters:
    `top` - the top inset >= 0
    `left` - the left inset >= 0
    `bottom` - the bottom inset >= 0
    `right` - the right inset >= 0

### getLeftInset

    protected final short getLeftInset()

  Gets the left inset.
  Returns:
    the inset >= 0

### getRightInset

    protected final short getRightInset()

  Gets the right inset.
  Returns:
    the inset >= 0

### getTopInset

    protected final short getTopInset()

  Gets the top inset.
  Returns:
    the inset >= 0

### getBottomInset

    protected final short getBottomInset()

  Gets the bottom inset.
  Returns:
    the inset >= 0

### getNextNorthSouthVisualPositionFrom

    protected int getNextNorthSouthVisualPositionFrom(int pos,
                                                      Position.Bias b,
                                                      java.awt.Shape a,
                                                      int direction,
                                                      Position.Bias[] biasRet)
                                               throws BadLocationException

  Returns the next visual position for the cursor, in either the east or west direction.
  Returns:
    next position west of the passed in position.

### getNextEastWestVisualPositionFrom

    protected int getNextEastWestVisualPositionFrom(int pos,
                                                    Position.Bias b,
                                                    java.awt.Shape a,
                                                    int direction,
                                                    Position.Bias[] biasRet)
                                             throws BadLocationException

  Returns the next visual position for the cursor, in either the east or west direction.
  Returns:
    next position west of the passed in position.

### flipEastAndWestAtEnds

    protected boolean flipEastAndWestAtEnds(int position,
                                            Position.Bias bias)

  Subclasses may wish to subclass this and conditionally return true based on the position. A return value of true indicates that when a View returns -1 from getNextVisualPositionFrom the next view for east should be the current index offset by -1, and for west it means offset by 1. The normal direction (for left to right text) is to offset east by 1 and west by -1.
  Returns:
    false

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Swing 1.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
Java is a trademark or registered trademark of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-1998 Sun Microsystems, Inc. 901 San Antonio Road,
Palo Alto, California, 94303, U.S.A. All Rights Reserved.